<template>
  <div class="container full-height">
    <div class="main-slide-container" id="fullpage">
      <section class="vertical-scrolling">
        <visual-component />
      </section>
      <section class="vertical-scrolling">
        <introduce-component />
      </section>
      <section class="vertical-scrolling">
        <drawable-image-component />
      </section>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'nuxt-property-decorator';
import { debounce } from 'debounce';
import VisualComponent from '../components/Visual.vue';
import IntroduceComponent from '../components/Introduce.vue';
import DrawableImageComponent from '../components/DrawableImage.vue';
import { commonModule, SlideName, Orientation } from '@/store/common/const';
import { CommonService } from '../services';

@Component({
  components: {
    VisualComponent,
    IntroduceComponent,
    DrawableImageComponent
  }
})
export default class IndexPage extends Vue {
  mainSlideOptions: any = {
    verticalCells: true,
    prevNextButtons: false,
    pageDots: false,
    wrapAround: true,
    speed: 300
  };
  mainSlide: any;

  @commonModule.State('currentSlide')
  public slide!: SlideName;
  @commonModule.State('canSwipeToOtherSlide')
  public canSwipeToOtherSlide!: SlideName;

  @commonModule.Action('changeToSlide')
  protected changeToSlide!: (slide: number) => void;
  @commonModule.Action('canSwipe')
  protected canSwipe!: (swiped: boolean) => void;

  @commonModule.Action('changeOrientation')
  protected changeOrientation!: (orientation: Orientation) => void;

  @Watch('slide', { immediate: true })
  onChangeSlide(val: SlideName, oldVal: SlideName) {
    if (jQuery && jQuery.fn.fullpage.moveTo) {
      jQuery.fn.fullpage.moveTo(val);
    }

    if (val === SlideName.DrawableImage) {
      this.canSwipe(false);
    }
  }

  layout() {
    return 'drawer';
  }

  orientationOnChange() {
    let width = 0;
    let height = 0;

    if (CommonService.isMobile()) {
      width = screen.width;
      height = screen.height;
    } else {
      width = window.innerWidth;
      height = window.innerHeight;
    }

    if (width > 0 && height > 0) {
      if (width > height) {
        this.changeOrientation(Orientation.Landscape);
      } else {
        this.changeOrientation(Orientation.Portrait);
      }
    }
  }

  onLeave(origin: number, destination: number) {
    if (this.canSwipeToOtherSlide) {
      this.changeToSlide(destination);
    }
    return this.canSwipeToOtherSlide;
  }

  beforeMount() {
    this.orientationOnChange();
    window.addEventListener('resize', this.orientationOnChange, false);
  }

  mounted() {
    jQuery(document).ready($ => {
      $('#fullpage').fullpage({
        sectionSelector: '.vertical-scrolling',
        controlArrows: false,
        onLeave: this.onLeave
      });
    });
  }
}
</script>

<style lang="scss">
html,
body {
  width: 100%;
  height: 100%;
  overflow-x: hidden;
}

body {
  font-family: 'Montserrat', sans-serif;
  position: fixed;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background: black;
}

@include Orientation(Portrait) {
  body {
    min-height: 90vh;
  }
}

@media (print), (prefers-reduced-motion) {
  .animated {
    animation: unset !important;
    transition: none !important;
  }
}

#__nuxt,
#__layout {
  height: 100%;
}

#app {
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: rgba(0, 0, 0, 0.3);
}

.main-slide > .swiper-wrapper {
  width: 100% !important;
  height: 100% !important;
}

.swiper-slide {
  width: 100%;
}

.full-height {
  height: 100% !important;
}

.container {
  width: 100%;
  height: 100%;
}

button {
  outline: none;
  background-color: transparent;
  border: none;
}

@include Orientation(Portrait) {
  .landscape {
    display: none !important;
  }
}

@include Orientation(Landscape) {
  .portrait {
    display: none !important;
  }
}
</style>
